namespace KillHostFromWorker;

public class WorkerCancelHost(IHostApplicationLifetime hostApplicationLifetime) : BackgroundService
{
    protected override async Task ExecuteAsync(CancellationToken stoppingToken)
    {
        int count = 0;
        while (!stoppingToken.IsCancellationRequested)
        {
            Console.WriteLine($"\tWorkerCancelHost: count = {++count}");

            if(count >= 3)
            {
                Console.WriteLine("\tWorkerCancelHost: Cancelling host from WorkerCancelHost");
                hostApplicationLifetime.StopApplication();
                break;
            }

            try 
            {
                await Task.Delay(1000, stoppingToken);
            }
            catch (TaskCanceledException)
            {
                Console.WriteLine("\tWorkerCancelHost: Task was cancelled during Task.Delay");
                break;
            }
        }
        Console.WriteLine("\tWorkerCancelHost: Exiting");
    }
}
